;-----------------------------------------------------------------------
;Wilfried Cordes, Kennedystrae 20, 2900 Oldenburg, Tel.: 0441-53088
;-----------------------------------------------------------------------
;Druckerpuffer (XBRA DPVA)
;-----------------------------------------------------------------------
;Erstellt mit TurboASS 1.36 (Shareware-Assembler)
;-----------------------------------------------------------------------
                         OUTPUT 'PFFR0110.PRG'
                         OPT F+

gemdos                   EQU 1
cconws                   EQU 9
fgetdta                  EQU 47
ptermres                 EQU 49
malloc                   EQU 72
mshrink                  EQU 74
fsfirst                  EQU 78

BIOSTrap                 EQU $B4

xbios                    EQU 14
supexec                  EQU 38

BusyVektor               EQU $0100

;Systemvariable--------------------------------------------------------
etv_timer                EQU $0400
_hz_200                  EQU $04BA

;MFP - General Purpose Input/Output Port-------------------------------
MFP_GPIP                 EQU $FFFFFA01
MFP_DDR                  EQU $FFFFFA05 ;Data Direction Register
MFP_AER                  EQU $FFFFFA03 ;Active Edge Register
MFP_IERB                 EQU $FFFFFA09 ;Interrupt Enable Register
MFP_ISRB                 EQU $FFFFFA11 ;Interrupt In Service
MFP_IMRB                 EQU $FFFFFA15 ;Interrupt Mask Register

;Programmable Sound Generator(PSG) - Register--------------------------
GISELECT                 EQU $FFFF8800
GIREAD                   EQU $FFFF8800
GIWRITE                  EQU $FFFF8802

                         TEXT

;Bentigten Speicher berechnen------------------------------------------
                         movea.l 4(SP),A0         ;Basepageadresse -> A0
                         move.l #256,D7           ;Basepagelnge
                         add.l 12(A0),D7          ;TEXT-Lnge
                         add.l 20(A0),D7          ;DATA-Lnge, kein BSS

                         move.l D7,-(SP)
                         move.l A0,-(SP)
                         clr.w -(SP)
                         move.w #mshrink,-(SP)
                         trap #gemdos
                         lea  12(SP),SP

;Datei suchen----------------------------------------------------------
                         clr.w -(SP)              ;Normale Datei
                         pea  Automuster(PC)      ;Suchmuster (Im Autoordner
                         move.w #fsfirst,-(SP)    ;            nachsehen)
                         trap #gemdos
                         addq.l #8,SP

                         tst.w D0                 ;Fehlercode=0 -> Okay
                         beq.s FINDE_DTA          ;ja

                         clr.w -(SP)              ;Normale Datei
                         pea  Wurzelmuster(PC)    ;Suchmuster (Im Wurzelverzeich-
                         move.w #fsfirst,-(SP)    ;            nis nachsehen)
                         trap #gemdos
                         addq.l #8,SP

                         tst.w D0                 ;Fehlercode=0 -> Okay
                         beq.s FINDE_DTA

                         lea  DATEI_FEHLT(PC),A6  ;Datei nicht gefunden

;Schlu nach Fehlern----------------------------------------------------
Schluss:                 bsr.s Melde
                         clr.w -(SP)
                         trap #gemdos

;DTA (Disk Transfer Address) finden-------------------------------------
FINDE_DTA:               move.w #fgetdta,-(SP)
                         trap #gemdos
                         addq.l #2,SP
                         movea.l D0,A0            ;DTA-Adresse -> A0

;Puffergre aus Namen holen und melden---------------------------------
                         lea  Gre+4(PC),A1      ;Position der Puffergre in Startmeldung
                         moveq #0,D6
                         move.b 37(A0),D6         ;Einser -> D6
                         move.b D6,-(A1)          ;Einser in Startmeldung schreiben
                         sub.b #48,D6             ;ASCII -> Zahl

                         move.b 36(A0),D1         ;Zehner -> D1
                         move.b D1,-(A1)
                         sub.b #48,D1             ;ASCII -> Zahl
                         ext.w D1
                         mulu #10,D1
                         add.w D1,D6              ;Anzahl Bytes KBytes -> D6

                         move.b 35(A0),D1         ;Hunderter -> D1
                         move.b D1,-(A1)
                         sub.b #48,D1             ;ASCII -> Zahl
                         ext.w D1
                         mulu #100,D1
                         add.w D1,D6              ;Anzahl KBytes -> D6

                         move.b 34(A0),D1         ;Tausender -> D1
                         move.b D1,-(A1)
                         sub.b #48,D1             ;ASCII -> Zahl
                         ext.w D1
                         mulu #1000,D1
                         add.w D1,D6              ;Anzahl KBytes -> D6

                         asl.l #5,D6              ;KBytes*(1024=2^10) = Bytes
                         asl.l #5,D6              ;Anzahl Bytes -> D6

                         move.l D6,Pufferkapazitt ;Puffergre speichern

;Speicherplatz prfen---------------------------------------------------
                         pea  -1                  ;Speicherplatz bestimmen
                         move.w #malloc,-(SP)
                         trap #gemdos
                         addq.w #6,SP

                         sub.l D6,D0              ;Vgl. ntigen, freien Speicher
                         sub.l #100000,D0         ;Etwas sollte briggelassen werden
                         bpl.s ERFOLG             ;freier Speicher gro genug

                         lea  HUCH(PC),A6         ;zu wenig Speicher
Schluss1:                bra.s Schluss            ;Ciao

;Stringausgabe----------------------------------------------------------
Melde:                   move.l A6,-(SP)
                         move.w #cconws,-(SP)
                         trap #gemdos
                         addq.l #6,SP
                         rts

;Busyvektor berprfen--------------------------------------------------
ERFOLG:                  pea  TesteBusyVektor(PC)
                         move.w #supexec,-(SP)
                         trap #xbios
                         addq.l #6,SP

                         cmpi.w #1,D0
                         beq.s KeinXBRA
                         blt.s Einklinken

;Puffer bereits vorhanden------------------------------------------------
                         lea  SCHON_DA(PC),A6
                         bra.s Schluss1           ;Abschied

;Busyvektor bereits verbogen-------------------------------------------
KeinXBRA:                lea  BELEGT(PC),A6
                         bra.s Schluss1

TesteBusyVektor:         btst #0,MFP_IERB.w       ;Busyinterrupt aktiviert?
                         bne.s SucheXBRA          ;ja
                         moveq #0,D0              ;nein
                         rts
SucheXBRA:               movea.l BusyVektor.w,A0
                         cmpi.l #"XBRA",-12(A0)   ;XBRA vorhanden?
                         beq.s SucheDPVA          ;ja
                         moveq #1,D0              ;nein
                         rts
SucheDPVA:               cmpi.l #"DPVA",-8(A0)    ;PFFR vorhanden?
                         beq.s DPVAGefunden       ;ja
                         moveq #1,D0              ;nein
                         rts
DPVAGefunden:            moveq #2,D0
                         rts

;Neue Einsprnge einklinken--------------------------------------------
Einklinken:              clr.l Schreibvektor      ;Zeiger initialisieren
                         clr.l Lesevektor
                         clr.l Pufferinhalt

                         move.l D6,-(SP)          ;Speicher vom TOS holen
                         move.w #malloc,-(SP)
                         trap #gemdos
                         addq.w #6,SP

                         move.l D0,Pufferadresse  ;Speicheradresse sichern

                         pea  Eintragen(PC)       ;Vektoren im Supervisormodus verbiegen
                         move.w #supexec,-(SP)
                         trap #xbios
                         addq.l #6,SP

                         lea  MELDUNG(PC),A6      ;Anwesenheit zeigen
                         bsr  Melde

                         clr.w -(SP)              ;Alles okay!
                         move.l D7,-(SP)          ;Anzahl Bytes
                         move.w #ptermres,-(SP)
                         trap #gemdos             ;Abtreten, ohne zu verschwinden

;Neuen Biosvektor eintragen--------------------------------------------
Eintragen:               movea.l #BIOSTrap,A0
                         move.l (A0),OLDVEKTOR
                         move.l #NEWBIOS,(A0)

;Neuen Busyvektor eintragen--------------------------------------------
                         movea.l #BusyVektor,A0
                         move.l (A0),Rette_BUSY_Interrupt
                         move.l #NeuerBusyInterrupt,(A0)

;Ports auf Eingang schalten--------------------------------------------
                         bclr #0,MFP_DDR.w        ;Data-Direction-Register
                         bclr #0,MFP_AER.w        ;Active-Edge-Register

;Busyinterrupt ermglichen---------------------------------------------
                         bset #0,MFP_IMRB.w       ;Interrupt Mask - Register B
                         bset #0,MFP_IERB.w       ;Interrupt Enable - Register B

;PSG-Register A und B auf Ausgang schalten-----------------------------
                         move.b #7,GISELECT.w
                         move.b GIREAD.w,D0
                         or.b #%11000000,D0
                         move.b D0,GIWRITE.w

;Neue etv_timer-Routine einhngen (50ms-Timer)-------------------------
                         movea.l #etv_timer,A0
                         move.l (A0),RetteEtvTimer
                         move.l #NeuerEtvTimer,(A0)

                         rts

;Puffersystemvariablen--------------------------------------------------
TimeOfLastOutput:        DC.L 0 ;[Systemticks]
Lesevektor:              DC.L 1 ;Zeiger auf Zeichen, das an den Drucker geht
Schreibvektor:           DC.L 1 ;Zeiger auf nchsten freien Platz im Puffer
Pufferadresse:           DC.L 0
Pufferkapazitt:         DC.L 0 ;[Bytes]
Pufferinhalt:            DC.L 0 ;-16(NEWBIOS)

;XBRA-Struktur----------------------------------------------------------
                         DC.B "XBRA"
                         DC.B "DPVA"
OLDVEKTOR:               DC.L -1

;Neuer BIOS-Einsprung---------------------------------------------------
NEWBIOS:                 lea  6(SP),A1
                         btst #5,(SP)             ;Im Supervisormodus aufgerufen?
                         bne.s Supermodus         ;ja
                         move USP,A1              ;nein, User-Stackpointer->A1

Supermodus:              movea.l OLDVEKTOR(PC),A0
                         tst.w 2(A1)              ;Drucker (PRN=0) ?
                         bne.s TOS
                         cmpi.w #3,(A1)           ;Zeichenausgabe
                         beq.s NEWBCONOUT
                         cmpi.w #8,(A1)           ;Ausgabestatus prfen
                         beq.s NEWBCOSTAT
TOS:                     jmp  (A0)                ;Nein -> normale BIOS-Routinen

;BCOSTAT (BIOS 8), Ausgabestatus berprfen-----------------------------
NEWBCOSTAT:              move.l Pufferkapazitt(PC),D0 ;Pufferkapazitt
                         cmp.l Pufferinhalt(PC),D0
                         ble.s Fehler
                         bra.s Erfolg

;BCONOUT (BIOS 3), Zeichenausgabe in Puffer-----------------------------
NEWBCONOUT:              move.l Pufferkapazitt(PC),D0
                         cmp.l Pufferinhalt(PC),D0
                         bgt.s bernehme

                         move.l _hz_200.w,D0
                         sub.l TimeOfLastOutput(PC),D0
                         cmpi.l #2000,D0          ;10 Sek. Geduld
                         blt.s NEWBCONOUT
Fehler:                  moveq #0,D0
                         rte

bernehme:               move.l Schreibvektor(PC),D0 ;erster freier Platz -> D0
                         movea.l Pufferadresse(PC),A0 ;Pufferadresse -> A0
                         move.b 5(A1),0(A0,D0.l)  ;Byte -> Puffer

                         addi.l #1,Pufferinhalt

                         addq.l #1,D0             ;Schreibvektor+1
                         cmp.l Pufferkapazitt(PC),D0 ;Svektor am Pufferende?
                         blt.s OKAY               ;Nein
                         moveq #0,D0              ;Ja, Svektor auf Pufferanfang setzen
OKAY:                    move.l D0,Schreibvektor  ;Svektor merken
                         move.l _hz_200.w,TimeOfLastOutput
Erfolg:                  moveq #-1,D0
                         rte

;XBRA-Struktur vor neuer Busy-Interruptroutine--------------------------
                         DC.B "XBRADPVA"
Rette_BUSY_Interrupt:    DC.L -1

;Interruptroutine. Liest Daten aus Puffer und gibt sie an Drucker-------
NeuerBusyInterrupt:      bsr.s SchreibeZeichen
                         move.b #%11111110,MFP_ISRB.w ;BusyInterrupt ist fertig
                         rte                      ;ReTurn from Exception

;XBRA-Struktur vor neuer etv-timer-Routine------------------------------
                         DC.B "XBRADPVA"
RetteEtvTimer:           DC.L -1

;Timerroutine, stt Druckausgabe an------------------------------------
NeuerEtvTimer:           move SR,-(SP)            ;rette Statusregister
                         bsr.s SchreibeZeichen
                         move (SP)+,SR
                         move.l RetteEtvTimer(PC),-(SP)
                         rts

;Eigentliche Ausgabe zur parallelen Schnittstelle-----------------------
SchreibeZeichen:         move #$2700,SR
                         btst #0,MFP_GPIP.w       ;Drucker BUSY?
                         bne.s GEHT_NICHT         ;Ja

                         movem.l D0-D1/A0,-(SP)   ;Register retten
                         tst.l Pufferinhalt       ;Ist Puffer leer?
                         beq.s Puffer_LEER        ;Ja

                         move.l Lesevektor(PC),D1
                         movea.l Pufferadresse(PC),A0 ;Pufferadresse -> A0

                         move.b #15,GISELECT.w    ;Port B des PSG anwhlen
                         move.b 0(A0,D1.l),GIWRITE.w ;Zeichen in Port B schreiben
;                                                 (=Centronics Datenleitungen)

                         move.b #14,GISELECT.w    ;Port A des PSG anwhlen
                         move.b GIREAD.w,D0
                         bclr #5,D0               ;Strobe auf low (Bit 5 lschen)
                         move.b D0,GIWRITE.w

                         subi.l #1,Pufferinhalt

                         bset #5,D0               ;Strobe auf high (Bit 5 setzen)
                         move.b D0,GIWRITE

                         addq.l #1,D1
                         cmp.l Pufferkapazitt(PC),D1 ;Lvektor am Pufferende?
                         blt.s OKAY1              ;Nein

                         moveq #0,D1              ;Lvektor auf Pufferanfang setzen
OKAY1:                   move.l D1,Lesevektor     ;Lesevektor merken

Puffer_LEER:             movem.l (SP)+,D0-D1/A0   ;Gerettete Register zurckschreiben
GEHT_NICHT:              rts

;Initialisierte Daten (Meldungen etc.)----------------------------------
                         DATA

Wurzelmuster:            DC.B "PFFR????.*",0

Automuster:              DC.B "\AUTO\PFFR????.PRG",0

MELDUNG:                 DC.B 13,10,"* PFFR wird eingeschaltet! *"
                         DC.B 13,10,"*    Gre: "
Gre:                   DC.B "     KBytes    *"
                         DC.B 13,10,"*      Wilfried Cordes     *"
                         DC.B 13,10,"*      Kennedystr. 20      *"
                         DC.B 13,10,"*      2900 Oldenburg      *",13,10,0

BELEGT:                  DC.B 13,10,"Busyvektor bereits verbogen.",0

SCHON_DA:                DC.B 13,10,"DruckerPuffer PFFR schon da!",0

HUCH:                    DC.B 13,10,"Speichermangel.",13,10
                         DC.B "Puffer wird nicht eingeschaltet.",13,10,0

DATEI_FEHLT:             DC.B 13,10,"PFFR????.PRG erstaunlicherweise nicht gefunden."
                         DC.B 13,10,0
                         END
