
          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
          ;
          ; ==========
          ; HPSPOOL.IS
          ; ==========
          ;
          ; Calamus printer driver for HP Laserjet+
          ;
          ;
          ; Autor     : WL
          ;
          ; Version   : 1.0
          ;
          ; Assembler :
          ;  GFA Assembler 1.1
          ;
          ; Disassembler :
          ;  < Detective >    Copyright 1986 FOCUS Computer Gmbh
          ;  Autor:  Detlev Ponnet                   Version 1.0
          ;
          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

          .TEXT 

          .DC.b 'CALAMUS'
          .DC.b 'CPD'

          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
          ;
          ; *** MAIN ENTRY POINT ***
          ;
          ;         jsr cpd_entry
          ;
          ;
          ;
          ; stack frame on entry :
          ; ----------------------
          ;
          ;
          ;   14(a6)     .l    move down # pixels
          ;   10(a6)     .l    pointer to info record ( see below )
          ;    8(a6)     .w    function = offset in jump table
          ;
          ;
          ; info record :
          ; -------------
          ;
          ;     $26
          ;     $22
          ;     $20
          ;     $1E  .w  offset in dpi table ( 0..75, 1..100, 2..150, 3..300 )
          ;     $18  .l  vertical offset in 1/720 inches
          ;     $14  .l  horizontal offset in 1/720 inches
          ;     $12  .w  number of lines
          ;     $10  .w
          ;     $0C  .l  length of data block to print = one line
          ;       8
          ;       4
          ;       0  .l  adr of data block to print ( all lines )
          ;
          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

cpd_entry:          
          link      a6,#0
          movem.l   d1-d7/a0-a5,-(sp)
          movea.w   #$8800,a2
          movea.w   #$fa01,a3
          moveq.l   #0,d0
          lea.l     L10036,a0
          move.w    8(a6),d1  ; function
          lsl.w     #2,d1
          adda.w    d1,a0
          movea.l   (a0),a0
          jmp       (a0)      ; jump indirect to function


          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;
          ;
          ; exit
          ;
          ; -> D0 ... status ( or ptr )
          ;

exit:     movem.l   (sp)+,d1-d7/a0-a5
          unlk      a6
          rts       


L10036:   
          .DC.l exit          ;
          .DC.l L10062        ; get ptr to printer characteristics data block
          .DC.l L1006a        ; init printer, start graphics
          .DC.l L100d6        ; exit printer, end graphics
          .DC.l L100e4        ; transfer lines
          .DC.l exit          ;
          .DC.l exit          ;
          .DC.l L101ca        ; move down # pixels
          .DC.l L101b2        ; (transfer block)
          .DC.l L101e6        ; NOP
          .DC.l exit          ;


L10062:   move.l    #L1027e,d0          ; printer characteristics
          bra.s     exit

L1006a:   
          movea.l   $a(a6),a1
          move.w    $22(a1),L10498

          move.l    $14(a1),d0          ; number
          lea.l     L1045f,a0 ; move current print position to decipoint
          bsr       number_to_ascii

          move.l    $18(a1),d0
          lea.l     L10467,a0 ; vertical offset
          bsr       number_to_ascii

          move.w    $1e(a1),d0          ;  offset in dpi table
          lsl.w     #2,d0     ; * 4
          lea.l     L103F0,a0 ; base adr of dpi table
          move.w    0(a0,d0.w),d0       ; get dpi value
          lea.l     L10457,a0 ; set dpi
          bsr       number_to_ascii

          lea.l     L10448,a0 ; init escape codes
          clr.l     d0
          move.w    $26(a1),d0
          divu      #10,d0
          addi.w    #'0',d0
          move.b    d0,9(a0)
          swap.w    d0
          addi.w    #'0',d0
          move.b    d0,10(a0)
          bsr       print_block
          bra       exit


L100d6:   lea.l     L10471,a0 ; end raster graphics
          bsr       print_block
          bra       exit

L100e4:   
          movea.l   $a(a6),a1

          movea.l   (a1),a4   ; adr of block  to print
          move.l    $c(a1),d7 ; length of block
          move.w    $12(a1),d6
          subq.w    #1,d6     ; # of lines

          move.l    d7,d0
          lea.l     L1047c,a0 ; ESC * b 0 0 0 0 W
          bsr       number_to_ascii
          subq.w    #1,d7
          clr.w     d5

          ; next line

L10104:   lea.l     L10478,a0 ; transfer graphics bytes
          bsr       print_block
          beq       exit      ; error

          ;
          ; print data block
          ;
          ; -> D7 .. len
          ;    A4 .. adr
          ;

          move.l    a4,-(sp)  ; address
          move.l    d7,d3     ; D7 must be constant for next line
          addq.l    #1,d3
          adda.l    d3,a4     ; move buffer pointer
          move.l    d3,-(sp)  ; count
          bsr       dospool
          addq.l    #8,sp
          tst.w     d0
          beq       Error

          ;          move.w    d7,d3
          ;next:     move.b    (a4)+,d0
          ;          bsr       L10200    ; transfer byte
          ;          dbne      d3,next   ; next byte
          ;          bmi       Error

          ; no error
          moveq.l   #0,d0
          tst.w     d0

          dbf       d5,L10184

          moveq.l   #$14,d5
          movem.l   d1-d7/a0-a6,-(sp)

          move.w    #2,-(sp)  ; CON:
          move.w    #1,-(sp)  ;bconstat
          trap      #$d       ;BIOS
          addq.w    #4,sp
          tst.l     d0
          beq       L10156    ; kein Zeichen von Tastatur verfgbar

          move.w    #2,-(sp)  ; CON:
          move.w    #2,-(sp)  ;conin
          trap      #$d       ;BIOS     Zeichen von CON: lesen
          addq.w    #4,sp
          cmpi.l    #$610000,d0         ; UNDO ?
          beq       L10156    ; ja

          clr.l     d0
L10156:   movem.l   (sp)+,d1-d7/a0-a6
          tst.l     d0
          beq       L10184

          ; ********************
          ; *** UNDO pressed ***
          ; ********************

          bsr       L101A8
          move.w    #1,UndoFlag
          lea.l     L1048B,a0 ; end raster graphics
          bsr       print_block

          clr.l     d0
          move.w    #1,d0
          bset.l    #$1f,d0   ; UNDO = $10000001

          bra       exit

L10184:   dbne      d6,L10104 ; next line
          bra       exit


Error:    
          bsr       timeout   ;;

          clr.w     UndoFlag
          bsr       L101A8

          move.l    d0,-(sp)  ; save error status
          lea.l     L1048B,a0 ; end raster graphics
          bsr       print_block
          move.l    (sp)+,d0

          bra       exit


L101A8:   movem.l   d0-d7/a0-a5,L1049A
          rts       


L101b2:   movem.l   L1049A,d0-d7/a0-a5

          tst.w     UndoFlag
          bne       L10104    ; ja, undo

          subq.l    #1,a4
          bra       L10104



          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
          ;
          ; move down # pixels
          ;
          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

L101ca:   move.l    $e(a6),d0
          lea.l     L10486,a0
          bsr       number_to_ascii
          lea.l     L10481,a0 ; move down # of pixels
          bsr       print_block
          bra       exit


L101e6:   clr.l     d0
          move.w    #$ffff,d0
          bra       exit



          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
          ;
          ; print block
          ;
          ; -> a0 ... points to data block
          ;           first byte in data block = length of block
          ;
          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

print_block:        
          clr.l     d3        ;;.w
          move.b    (a0)+,d3  ; # of bytes to print

          move.l    a0,-(sp)  ; address
          addq.l    #1,d3
          move.l    d3,-(sp)  ; count
          bsr       dospool
          addq.l    #8,sp
          tst.w     d0
          beq       spoolerror

          ; no error

          moveq.l   #0,d0
          tst.w     d0
          rts       

          ;L101F4:   move.b    (a0)+,d0
          ;          bsr       L10200    ; output char
          ;          dbne      d3,L101F4
          ;          rts

spoolerror:         
          bsr       timeout
          rts       




          .IF 0

          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
          ;
          ; output char
          ;
          ; -> D0.b .. character
          ;
          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

L10200:   move.l    #1000,d4  ; 5 sekunden
          add.l     $4ba,d4   ; 200 HZ interrupt

L1020A:   btst.b    #0,(a3)   ; busy ?
          beq       Centronics_Out      ; no
          cmp.l     $4ba,d4   ; 200 Hz interrupt
          bhi.s     L1020A

          .ENDIF 


          ; *** printer timeout ***
timeout:  
          clr.l     d0
          move.w    #$fffc,d0
          bset.l    #$1f,d0
          tst.w     d0

          rts       




          .IF 0

          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
          ;
          ; centronics output routine
          ;
          ; -> D0 .. character to output
          ;
          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Centronics_Out:     
          move.w    sr,d1
          ori.w     #$700,sr

          move.b    #7,(a2)
          move.b    (a2),d2
          bset.l    #7,d2
          move.b    d2,(a2)
          move.b    #$f,(a2)
          move.b    d0,2(a2)
          move.b    #$e,(a2)
          move.b    (a2),d2
          bclr.l    #5,d2
          move.b    d2,2(a2)
          bset.l    #5,d2
          nop       
          nop       
          move.b    d2,2(a2)

          move.w    d1,sr

          moveq.l   #0,d0
          tst.w     d0
          rts       

          .ENDIF 




          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
          ;
          ; convert number in D0 to ascii
          ;
          ; -> D0 .. number
          ;    A0 .. address to store ascii string
          ;
          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

number_to_ascii:    
          move.l    #1000,d1
L10268:   
          divu      d1,d0
          addi.w    #'0',d0
          move.b    d0,(a0)+
          clr.w     d0
          swap.w    d0
          divu      #10,d1
          tst.w     d1
          bne.s     L10268
          rts       



          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
          ;
          ; dospool
          ;
          ; transfers count bytes starting at address adr to printer
          ; via extended SPLX functions,
          ; or standard $50a vector call if SPLX is not installed
          ;
          ;
          ; CALL SYNTAX :
          ;
          ;   move.l    adr,-(sp)  ; address
          ;   move.l    count,-(sp)         ; count
          ;   bsr       dospool
          ;   addq.l    #8,sp
          ;   tst.w     d0
          ;   beq       spoolerror
          ;
          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

adr       = 12
len       = 8
dospool:  
          link      a6,#0
          movem.l   d1-d7/a0-a5,-(sp)   ; save regs

          bsr       testspooler
          bne       nospooler

          move.l    adr(a6),-(sp)       ; adr
          move.l    len(a6),-(sp)       ; len
          move.l    #'SPLB',-(sp)
          suba.l    a5,a5
          movea.l   $50a(a5),a0         ; vektor send char to printer
          ;;                              (parallel port)
          jsr       (a0)
          adda.l    #12,sp
          tst.w     d0
          bne       spoolok

          ; spool not ok, send bytes individually

nospooler:          
          move.l    len(a6),d1
          subq.l    #1,d1
          movea.l   adr(a6),a3
n_byte:   
          move.b    (a3)+,d0  ; next byte
          bsr       druck
          beq       printerr

          dbra      d1,n_byte ; next byte
printerr: 
spoolok:  
          movem.l   (sp)+,d1-d7/a0-a5   ; restore regs
          unlk      a6
          rts       


druck:              ;prints char in d0
          movem.l   d1-d7/a0-a6,-(sp)
          ext.w     d0
          move.w    d0,-(sp)
          move.w    d0,-(sp)
          suba.l    a5,a5
          movea.l   $50a(a5),a0         ; vektor send char to printer
          ;;                              (parallel port)
          jsr       (a0)
          addq.l    #4,sp
          movem.l   (sp)+,d1-d7/a0-a6
          tst.w     d0
          rts       


          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
          ;
          ; test if extended SPLX functions available
          ;
          ; must be in supervisor mode for this call
          ;
          ;
          ; bsr setspooler
          ; beq spooler_available
          ;
          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

testspooler:        
          movea.l   $50a,a0   ; supervisor access
          cmpi.l    #'XBRA',-12(a0)
          bne       nospl
          cmpi.l    #'SPLX',-8(a0)
nospl:    rts       


          .IF 0
          suba.l    a5,a5
          movea.l   $506(a5),a0         ; vektor printer status ( system var )
          jsr       (a0)
          tst.w     d0        ; printer ready ?
          beq.s     ende      ; no, end
          .ENDIF 

          ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


          .DATA 

L1027e:   
          .DC.w 1000
          .DC.w $10
          .DC.w $3a
          .DC.w 99

          .DC.w 6   ; 6 paper sizes
          .DC.l L102b8

          .DC.w 4   ; 4 resolutions : 75 / 100 / 150 / 300
          .DC.l L103F0

          .DC.w 3   ; 3 modes : Kassette / Einzelblatt / Briefumschlag
          .DC.l L10400

          .DC.l 0

          .DC.b 'HP Deskjet  (Spool V1.0)',0
          ;      --------------------------------             ;max len
          .DC.b 0


          ;-------------------------------------------------------
          ;
          ; paper sizes
          ;
L102b8:   
          ; A5                            14.85 cm x 21.00 cm
          .DC.w 0,0,0,0,0,0,0,$0,$0,$0,$0,$1071,$0,$1741,0,0,0,0,8,8,1,1,0,0,0,0

          ; A4                            21.00 cm x 29.70 cm
          .DC.w 0,1,0,0,0,0,0,$dc,0,$171,0,$1651,0,$1ed6,0,0,0,0,8,8,1,1,0,0,0,0

          ; B5                            17.60 cm x 25.00 cm
          .DC.w 0,3,0,0,0,0,0,$0,$0,$0,$0,$137d,$0,$1baf,0,0,0,0,8,8,1,1,0,0,0,0

          ; Letter                        21.59 cm x 27.94 cm
          .DC.w 0,4,0,0,0,0,0,$0,$0,$0,$0,$17e8,$0,$1ef0,0,0,0,0,8,8,1,1,0,0,0,0

          ; Legal                         21.59 cm x 35.56 cm
          .DC.w 0,5,0,0,0,0,0,$0,$0,$0,$0,$17e8,$0,$2760,0,0,0,0,8,8,1,1,0,0,0,0

          ; Half                          13.97 cm x 21.59 cm
          .DC.w 0,7,0,0,0,0,0,$0,$0,$0,$0,$0f78,$0,$17e8,0,0,0,0,8,8,1,1,0,0,0,0


          ;-------------------------------------------------------

L103F0:             ;      ; DPI x DPI
          .DC.w 75,75
          .DC.w 100,100
          .DC.w 150,150
          .DC.w 300,300

          ;-------------------------------------------------------

L10400:   .DC.w 0
          .DC.l L10412

          .DC.w 1
          .DC.l L1041b

          .DC.w 0
          .DC.l L10430

L10412:   .DC.b 'Kassette',0
L1041b:   .DC.b 'Einzelblattzufhrung',0
L10430:   .DC.b 'Briefumschlag-Zufhrung',0


          ;----------------------------------------
L10448:   
          .DC.b e1-L10448-2   ; len

          .DC.b $1b,'&l0O'    ; *** UNDEFINED FOR DESKJET ***

          .DC.b $1b,'&l'
          .DC.b 0,0,'X'       ; *** UNDEFINED FOR DESKJET ***

          .DC.b $1b,'*t'
L10457:   .DC.b 0,0,0,0,'R'   ; SET DPI

          .DC.b $1b,'&a'
L1045f:   .DC.b 0,0,0,0,'H'   ; HORIZONTAL POSITION

          .DC.b $1b,'&a'
L10467:   .DC.b 0,0,0,0,'V'   ; VERTICAL POSITION

          .DC.b $1b,'*r1A'    ; START RASTER GRAPHICS AT CURRENT POS
e1:       

          ;-------------------------------------------

L10471:   .DC.b e2-L10471-2   ; len

          .DC.b $1b,'*rB'     ; END RASTER GRAPHICS
          .DC.b $1b,'E'       ; RESET
e2:       

          ;-------------------------------------------

L10478:   .DC.b e3-L10478-2   ; len

          .DC.b $1b,'*b'
L1047c:   .DC.b 0,0,0,0,'W'   ; TRANSFER GRAPHICS BYTES
e3:       

          ;-------------------------------------------

L10481:   .DC.b e4-L10481-2   ; len

          .DC.b $1b,'*p+'
L10486:   .DC.b 0,0,0,0,'Y'   ; MOVE DOWN # PIXELS
e4:       

          ;-------------------------------------------

L1048B:   .DC.b e5-L1048B-2   ; len

          .DC.b $1b,'*rB'     ; END RASTER GRAPHICS
          .DC.b $1b,'&l0X'    ; *** UNDEFINED FOR DESKJET ***
          .DC.b $1b,'-',0     ; *** UNDEFINED FOR DESKJET ***
e5:       

          ;-------------------------------------------


          ;; Detective -- Datenbereich ;;;;;;;;;;;;;;;;;;;;;;;;;;;

          .BSS 

L10498:   .DS.w 1

L1049A:   .DS.b $40 ; register save area

UndoFlag: .DS.w 1


          ;; Detective -- Ende ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

          .END 

