{$S0}
PROGRAM  drucker_init ;                  { Version fr den PANASONIC KX-P1091 }

{-----------------------------------------------------------------------------}
{  Dieses von der Wurmsoftware entwickelte Programm, erlaubt eine bequeme     }
{  Druckeranpassung. Es wird als DESK ACCESSORY installiert und ist so        }
{  von jedem GEM-Programm aus zu erreichen.                                   }
{  Entwickelt wurde das Programm mit den PASCAL PLUS System von CCD.          }
{                                                                             }
{  Autoren: Thomas Proffen & Martin Schultz                                   }
{ (c) Wurmsoftware BONN                                          22.08.86     }
{-----------------------------------------------------------------------------}

CONST
  rsc_filename = 'DRUCKER.RSC' ;
  {$I gemconst.pas}
  {$I C:\drucker\drucker.i}

TYPE
  {$I gemtype.pas}

VAR
  ap_id,                                           { Nummer unserer Anwendung }
  window, junk, pushed,                 { Hilfsvariablen fr Funktionsaufrufe }
  menu_id,                                     { Nummer unseres Meneintrages }
  config                    : integer ;          { Drucker-Konfigurationsbyte }
  our_name                  : str255 ;                    { Accessory-Eintrag }
  menu                      : Dialog_Ptr ;        { Zeiger auf Dialogstruktur }
  no_dialog                 : boolean ;        { Flag fr ersten Dialogaufruf }



  {$I gemsubs.pas}


{ ---------------------- Drucker-Systemfunktionen -------------------------- }

FUNCTION drucker_test (dev : integer) : integer ; BIOS (8);


FUNCTION setprt (config : integer) : integer ; XBIOS(33) ;


{ ---------------------- Fenster fr Dialogbox ffnen ----------------------- }

PROCEDURE Do_Open_Window (VAR window : integer);

  VAR dummy : str255;

  BEGIN
   window := New_Window (0, dummy, 0, 0, 0, 0);
   Open_Window (window, 0, 0, 0, 0);
  END;


{ ----------------------- Fenster bei Abbruch schlieen --------------------- }

PROCEDURE Do_Close_Window (window : integer);

  BEGIN
   Close_Window (window);
   Delete_Window (window);
  END;


{ ------------------ Dialogbox auf den Bildschirm bringen ------------------- }

PROCEDURE Do_Open_Dialog ;

  BEGIN
   IF no_dialog = false THEN
    pushed := Do_Dialog (menu, drucker)
   ELSE
    BEGIN
     Obj_SetState (menu, elite,    selected, true) ;
     Obj_SetState (menu, artnorm,  selected, true) ;
     Obj_SetState (menu, lr6,      selected, true) ;
     Obj_SetState (menu, sl12,     selected, true) ;
     Obj_SetState (menu, uberspr,  selected, true) ;
     pushed := Do_Dialog (menu, drucker) ;
     no_dialog := false ;
    END ;
  END ;


{ ----------------- Drucker (PANASONIC KX-P1091) initialisieren ------------- }

{ Die Steuerzeichen sind grtenteils EPSON-kompatibel !                      }

PROCEDURE drucker_init;

  BEGIN
   rewrite (output, 'PRN:');                            { Ausgabe auf Drucker }
   write (chr(27),'@') ;                                      { Drucker-Reset }

   IF Obj_State (menu, lr2) & Selected <> 0 THEN         { linker Rand = 2 }
    write (chr (27), 'l', chr (2));
   IF Obj_State (menu, lr4) & Selected <> 0 THEN         {             = 4 }
    write (chr (27), 'l', chr (4));
   IF Obj_State (menu, lr6) & Selected <> 0 THEN         {             = 6 }
    write (chr (27), 'l', chr (6));
   IF Obj_State (menu, lr8) & Selected <> 0 THEN         {             = 8 }
    write (chr (27), 'l', chr (8));
   IF Obj_State (menu, lr10) & Selected <> 0 THEN        {             =10 }
    write (chr (27), 'l', chr (10));

   IF Obj_State (menu, schmal) & Selected <> 0 THEN       { Schmalschrift }
    write (chr (15));
   IF Obj_State (menu, nlq) & Selected <> 0 THEN          { NLQ }
    write (chr (27), 'n');              { fr EPSON Doppeldruck (chr(27),'G') }

   IF Obj_State (menu, elite) & Selected <> 0 THEN        { Elite }
    write (chr (27), 'M');
   IF Obj_State (menu, italic) & Selected <> 0 THEN       { Italic }
    write (chr (27), '4');

   IF Obj_State (menu, sl10) & Selected <> 0 THEN         { Seitenlnge = 10' }
    write (chr (27), 'C', chr (0), chr (10));
   IF Obj_State (menu, sl12) & Selected <> 0 THEN         {             = 12' }
    write (chr (27), 'C', chr (0), chr (12));

   IF Obj_State (menu, uberspr) & Selected <> 0 THEN {Perforation berspringen}
    write (chr (27), 'N', chr (8))

   rewrite (output, 'CON:');

   config := setprt(-1) ;                       { Drucker-System-Status lesen }
   config := config OR 4 ;
   config := setprt(config) ;                  { auf EPSON stellen (960 Pkte) }
  END;


{ ------------------- Ereignisschleife, die alles berwacht ----------------- }

PROCEDURE Event_Loop (VAR window : integer);

  VAR  event, dummy, auswahl, d_test  : integer ;
       msg                            : Message_Buffer ;


  BEGIN
   WHILE true DO
    BEGIN
     event := Get_Event (E_Message, 0, 0, 0, 0, false,
                         0, 0, 0, 0, false, 0, 0, 0, 0,
                         msg, dummy, dummy, dummy, dummy,
                         dummy, dummy ) ;
     IF msg[0] = AC_Open THEN                { Das Accessory wurde ausgewhlt }
      BEGIN
       Do_Open_Window (window);                { Fenster fr Dialogbox ffnen }
       Do_Open_Dialog ;                        { Dialog fhren                }
       End_Dialog (menu) ;                    { Dialog vom Bildschirm lschen }
       Obj_SetState (menu, ok,    normal, true) ;     {OK-Button zurcksetzen }
       REPEAT
        d_test := drucker_test (0);                { Spricht der Drucker an ? }
        IF d_test = -1 THEN
         drucker_init
        ELSE
         auswahl := Do_Alert
         ('[3][Drucker ist nicht ON LINE !][Abbruch | Wiederholung]',2);
       UNTIL (auswahl = 1) OR (d_test = -1);
       Do_Close_Window (window);                          { Fenster schlieen }
      END;

    END ;
  END ;



{ ****************************  HAUPTPROGRAMM  ****************************** }

BEGIN
  ap_id := Init_Gem ;                        { Nummer unserer Anwendung holen }
  IF ap_id > 0 THEN
    BEGIN
      our_name := '  Drucker Init  ' ;       { Eintragen unserer Anwendung in }
      menu_id := Menu_Register (ap_id, our_name) ;            { die Menzeile }
      IF NOT Load_Resource (rsc_filename) THEN          { Laden des RSC-Files }
        BEGIN
          junk := Do_Alert ('[3][Kein Resource-File gefunden][Abbruch]',0) ;
          Exit_Gem ;                { Falls nicht gefunden, Abbruch und RESET }
          Halt ;
        END ;
      Find_Dialog (drucker, menu) ;                    { Dialogpointer setzen }
      no_dialog := true ;           { erster Aufruf, Voreinstellung der Werte }
      Center_Dialog (menu) ;              { Dialog in Bildschirmmitte bringen }
      Event_Loop (window);                     { Sprung in die Endlosschleife }
    END ;
END.



{ ===========================================================================

            E r l  u t e r u n g e n     zu   DRUCKER_INIT

  ===========================================================================


  Dieses Programm ist als Desk-Accessory geschrieben, und von daher so ohne
  weiteres nicht lauffhig. Wenn Sie nderungen am Quelltext vornehmen wollen,
  sollten Sie Ihr PASCAL-Plus Handbuch zu Rate ziehen, wie Sie das Accessory
  anschlieend lauffhig machen.

  ACHTUNG !!  Wenn Sie das Accessory auf andere Disketten kopieren, vergessen
  Sie nicht, das RSC-File mitzukopieren, sonst wird der Computer stndig neu
  RESETTEN. Wollen Sie den Namen des .RSC-Files ndern, mssen Sie ihn auch
  im Quelltext in der Konstantendeklaration ndern, sonst passiert dasselbe.

  Zu den einzelnen Routinen :
    FUNCTION drucker_test (dev : integer)      [ BIOS(8) ]
      Mit dieser Funktion wird getestet, ob das Gert dev zur Aufnahme von
      Daten bereit ist. Sie gibt -1 zurck, falls ja, sonst 0.

    FUNCTION setprt (config : integer)         [ XBIOS (33) ]
      Durch diese Funktion wird die Drucker-Einstellung, wie sie im Accessory
      'Drucker anpassen' (CONTROL.ACC) gesetzt werden kann, getestet und
      gesetzt. bergibt man den Wert -1, wird sie getestet, sonst entsprechend
      folgender Bedeutung gesetzt:

           Bit                0                       1

             0           Matrixdrucker          Typenraddrucker
             1           Farbdrucker            s/w-Drucker
             2           ATARI-Drucker          EPSON-Drucker  (Pkte/Zeile)
             3           Entwurf-Modus          NLQ-Modus
             4           Parallel-Port          Serielle RS232-Schnittstelle
             5           Endlospapier           Einzelblatt
        6 - 14                       reserviert
            15           mu zum Setzen 0 sein (siehe oben).

    PROCEDURE Do_Open_Window
      Damit das Betriebssystem nach Beendigung des Dialoges den darunter
      liegenden Bildschirminhalt wiederherstellen kann, mu die Anwendung
      ein Fenster ffnen. Das Fenster wird 'leer' definiert, das heit es
      hat weder Titelzeile, noch Close-Box, Shrink-Box, ...

    PROCEDURE Do_Close_Window
      Mit dieser Routine wird das Fenster geschlossen und damit zum auf-
      rufenden Programm zurckgekehrt.

    PROCEDURE Do_Open_Dialog
      Durch diesen Aufruf wird der Dialog auf den Bildschirm gebracht, und
      GEM bernimmt die Dialogfhrung. Handelt es sich um den ersten Aufruf,
      so werden einige Werte voreingestellt, was durch die Variable No_Dialog
      kontrolliert wird. Voreingestellt werden :
      ELITE, NORMAL, linker Rand = 6, Seitenlnge = 12', Perf. berspringen.

    PROCEDURE drucker_init
      Nachdem der Dialog mit OK abgebrochen wurde, werden in dieser Prozedur
      die eingestellten Parameter ausgewertet und die entsprechenden Steuer-
      zeichen an den Drucker gesendet. Auerdem wird die Konfiguration auf
      EPSON gestellt, was eine Hardcopy von 960 Punkten pro Zeile bewirkt.

      Die 'Normal'-Einstellungn von Schriftart und -typ erfolgt durch den
      vorausgehenden Drucker-Reset automatisch.

    PROCEDURE Event_Loop
      Da es sich bei dem Programm um ein Accessory handelt, mu hier in einer
      Endlosschleife (WHILE true ist immer wahr) stndig getestet werden, ob
      unser Meneintrag aufgerufen wurde. Falls dies eintritt, wird von hier
      aus der Dialog aufgerufen.

    HAUPTPROGRAMM
      Bei einem Accessory erfllt ein Hauptprogramm nur die Funktion, es zu
      Beginn (beim Einschalten oder RESET) zu aktivieren. Zuerst wird der
      Anwendung eine Applikationsnummer zugeteilt, dann wird das RSC-File zu
      diesem Programm geladen (hier sind die Daten fr die Dialogbox ge-
      speichert), und anschlieend wird ein Eintrag in die Accessory-Leiste
      vorgenommen. Zum Schlu erfolgt der Sprung in die Endlosschleife
      Event_Loop (siehe oben).

                                                                          MS }
